<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignSearch StructType
 * @subpackage Structs
 */
class CampaignSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchBasic
     */
    public $basic;
    /**
     * The campaignRecipientJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchBasic
     */
    public $campaignRecipientJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchBasic
     */
    public $fileJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesJoin;
    /**
     * The originatingLeadJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OriginatingLeadSearchBasic
     */
    public $originatingLeadJoin;
    /**
     * The promotionCodeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PromotionCodeSearchBasic
     */
    public $promotionCodeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CampaignSearch
     * @uses CampaignSearch::setBasic()
     * @uses CampaignSearch::setCampaignRecipientJoin()
     * @uses CampaignSearch::setFileJoin()
     * @uses CampaignSearch::setMessagesJoin()
     * @uses CampaignSearch::setOriginatingLeadJoin()
     * @uses CampaignSearch::setPromotionCodeJoin()
     * @uses CampaignSearch::setTransactionJoin()
     * @uses CampaignSearch::setUserJoin()
     * @uses CampaignSearch::setUserNotesJoin()
     * @uses CampaignSearch::setCustomSearchJoin()
     * @param \StructType\CampaignSearchBasic $basic
     * @param \StructType\EntitySearchBasic $campaignRecipientJoin
     * @param \StructType\FileSearchBasic $fileJoin
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @param \StructType\OriginatingLeadSearchBasic $originatingLeadJoin
     * @param \StructType\PromotionCodeSearchBasic $promotionCodeJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\CampaignSearchBasic $basic = null, \StructType\EntitySearchBasic $campaignRecipientJoin = null, \StructType\FileSearchBasic $fileJoin = null, \StructType\MessageSearchBasic $messagesJoin = null, \StructType\OriginatingLeadSearchBasic $originatingLeadJoin = null, \StructType\PromotionCodeSearchBasic $promotionCodeJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, \StructType\NoteSearchBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCampaignRecipientJoin($campaignRecipientJoin)
            ->setFileJoin($fileJoin)
            ->setMessagesJoin($messagesJoin)
            ->setOriginatingLeadJoin($originatingLeadJoin)
            ->setPromotionCodeJoin($promotionCodeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CampaignSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CampaignSearchBasic $basic
     * @return \StructType\CampaignSearch
     */
    public function setBasic(\StructType\CampaignSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get campaignRecipientJoin value
     * @return \StructType\EntitySearchBasic|null
     */
    public function getCampaignRecipientJoin()
    {
        return $this->campaignRecipientJoin;
    }
    /**
     * Set campaignRecipientJoin value
     * @param \StructType\EntitySearchBasic $campaignRecipientJoin
     * @return \StructType\CampaignSearch
     */
    public function setCampaignRecipientJoin(\StructType\EntitySearchBasic $campaignRecipientJoin = null)
    {
        $this->campaignRecipientJoin = $campaignRecipientJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchBasic $fileJoin
     * @return \StructType\CampaignSearch
     */
    public function setFileJoin(\StructType\FileSearchBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @return \StructType\CampaignSearch
     */
    public function setMessagesJoin(\StructType\MessageSearchBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get originatingLeadJoin value
     * @return \StructType\OriginatingLeadSearchBasic|null
     */
    public function getOriginatingLeadJoin()
    {
        return $this->originatingLeadJoin;
    }
    /**
     * Set originatingLeadJoin value
     * @param \StructType\OriginatingLeadSearchBasic $originatingLeadJoin
     * @return \StructType\CampaignSearch
     */
    public function setOriginatingLeadJoin(\StructType\OriginatingLeadSearchBasic $originatingLeadJoin = null)
    {
        $this->originatingLeadJoin = $originatingLeadJoin;
        return $this;
    }
    /**
     * Get promotionCodeJoin value
     * @return \StructType\PromotionCodeSearchBasic|null
     */
    public function getPromotionCodeJoin()
    {
        return $this->promotionCodeJoin;
    }
    /**
     * Set promotionCodeJoin value
     * @param \StructType\PromotionCodeSearchBasic $promotionCodeJoin
     * @return \StructType\CampaignSearch
     */
    public function setPromotionCodeJoin(\StructType\PromotionCodeSearchBasic $promotionCodeJoin = null)
    {
        $this->promotionCodeJoin = $promotionCodeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\CampaignSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\CampaignSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @return \StructType\CampaignSearch
     */
    public function setUserNotesJoin(\StructType\NoteSearchBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $campaignSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$campaignSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($campaignSearchCustomSearchJoinItem) ? get_class($campaignSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($campaignSearchCustomSearchJoinItem), var_export($campaignSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\CampaignSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\CampaignSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
